"""Class to use a bitmap head for a ragdoll anim"""

import pygame

import math

import limb

class Head(limb.Limb):
    """Limb that draws a bitmap, such as a head"""
    def __init__(self, p1, p2, bitmap, color):
        self.target = math.pi/2
        limb.Limb.__init__(self, p1, p2, 0, color, self.target)
        self.orig_image = bitmap
        
    def update(self):
        pass
        #diff = self.target - self.get_angle()
        #self.rotate(diff)

        #for limb in self.p1limbs:
        #    limb.p1 = self.p1
        #    limb.update()
        #for limb in self.p2limbs:
        #    limb.p1 = self.p2
        #   limb.update()

    def draw(self, image):
        limb.Limb.draw(self, image)
        rect = image.get_rect()
        rect.center = self.p2
        image.blit(pygame.transform.rotate(self.orig_image, self.get_angle()), rect)
        
    def set_color(self, color):
        array = pygame.surfarray.pixel2d(self.image)
        for row in array:
            for pix in row:
                if pygame.Color(pix) == self.color:
                    pix = color
        self.color = pygame.Color(color)
