"""A class to implement ragdolls so that the character class can focus on other game mechanics"""

import math, ConfigParser, os.path

import pygame

import entity, head, limb

class Ragdoll:
    """Takes care of the physics and animation for the Character class
    
    Needs to eventually take all of it's points from a .phys file, but I don't
    have the time"""
    def __init__(self, color, headpic, moves):
        self.moves = ConfigParser.SafeConfigParser()
        self.moves.readfp(open(os.path.normcase(os.path.normpath(moves))))
        self.color = color
        self.limbs = {"head": head.Head([16, 25], [15, 10], pygame.image.load(os.path.normcase(\
            os.path.normpath(headpic))).convert(), 4294967295L),\
            "body": limb.Limb([15, 42], [16, 25], 1, 4294967295L, math.pi/2),\
            "rthigh": limb.Limb([15, 42], [8, 52], 1, 4294967295L, math.pi/4),\
            "rshin": limb.Limb([8, 52], [0, 62], 1, 4294967295L, math.pi/2),\
            "lthigh": limb.Limb([15, 42], [23, 52], 1, 4294967295L, (math.pi*3)/4),\
            "lshin": limb.Limb([23, 52], [31, 62], 1, 4294967295L, math.pi/2),\
            "ruarm": limb.Limb([16, 25], [8, 35], 1, 4294967295L, 0),\
            "rlarm": limb.Limb([8, 35], [0, 46], 1, 4294967295L, 0),\
            "luarm": limb.Limb([16, 25], [23, 35], 1, 4294967295L, math.pi),\
            "llarm": limb.Limb([23, 35], [31, 46], 1, 4294967295L, math.pi)}
        # extensive setup, link the limbs
        self.limbs["body"].p1limbs.append(self.limbs["head"])
        self.limbs["body"].p1limbs.append(self.limbs["ruarm"])
        self.limbs["body"].p1limbs.append(self.limbs["luarm"])
        self.limbs["ruarm"].p2limbs.append(self.limbs["rlarm"])
        self.limbs["luarm"].p2limbs.append(self.limbs["llarm"])
        self.limbs["body"].p2limbs.append(self.limbs["rthigh"])
        self.limbs["body"].p2limbs.append(self.limbs["lthigh"])
        self.limbs["rthigh"].p2limbs.append(self.limbs["rshin"])
        self.limbs["lthigh"].p2limbs.append(self.limbs["lshin"])
            
    def update(self):
        self.limbs["body"].update()
            
    def set_color(self, color):
        for limb in self.limbs.values():
            limb.set_color(color)
    
    def get_image(self):
        width = max([limb.p2[0] for limb in self.limbs.values()])
        height = max([limb.p2[1] for limb in self.limbs.values()])
        img =  pygame.Surface((width, height), 0, 32)
        img.fill(pygame.Color(0, 0, 0, 0))
        return img
        
    def draw(self):
        image = self.get_image()
        for limb in self.limbs.values():
            limb.draw(image)
        return image
